<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglContainersBiVertexBase.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_5e9011f35b9434939eeeb25c7dbf1304.html">containers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglContainersBiVertexBase.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglContainersBiVertexBase_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLCONTAINERSBIVERTEXBASE_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLCONTAINERSBIVERTEXBASE_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersVertexBase_8hpp.html">tiglContainersVertexBase.hpp</a>&quot;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="comment"> * NAMESPACE</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment"> * TIGLContainersBiVertexBase class</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType, <span class="keyword">typename</span> AlgDataType, <span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> IdType = u<span class="keywordtype">int</span>_fast32_t&gt;</div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html">   74</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLContainersBiVertexBase.html">TIGLContainersBiVertexBase</a>: <span class="keyword">public</span> <a class="code" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt;DataType, AlgDataType, EdgeType, IdType&gt;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;{</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase&lt;DataType, AlgDataType, EdgeType, IdType&gt;</a> <a class="code" href="classTIGLContainersVertexBase.html">VERTEX_TYPE</a>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> VERTEX_TYPE::OUT_EDGE_ITERATOR EDGE_ITERATOR;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;   <span class="keyword">typedef</span> EDGE_ITERATOR IN_EDGE_ITERATOR;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;   <a class="code" href="classTIGLContainersBiVertexBase.html">TIGLContainersBiVertexBase</a>(IdType key) :</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;         <a class="code" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase&lt;DataType, AlgDataType, EdgeType, IdType&gt;</a>(key)</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;   {</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;   }</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;   ~<a class="code" href="classTIGLContainersBiVertexBase.html">TIGLContainersBiVertexBase</a>()</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   {</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;   }</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#a05f5f7777608e6b5c50f3ec7a52157e1">  108</a></span>&#160;   vector&lt;EdgeType&gt; <a class="code" href="classTIGLContainersBiVertexBase.html#a05f5f7777608e6b5c50f3ec7a52157e1">inEdges</a>;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="comment">    * methods</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#afd76ce0d0b3abcb3d639041db92c4f1b">  121</a></span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersBiVertexBase.html#afd76ce0d0b3abcb3d639041db92c4f1b">addInEdge</a>(EdgeType &amp; x)</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;   {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;      inEdges.push_back(x);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;   }</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00131"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#a8a442d0b79dda8ef28c14862392a2374">  131</a></span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersBiVertexBase.html#a8a442d0b79dda8ef28c14862392a2374">addInEdge</a>(IdType &amp; src)</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;   {</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;      EdgeType newEdge(src);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      inEdges.push_back(newEdge);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;   }</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00142"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#a0115e80a8874748ad4252a8f5381c9ca">  142</a></span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersBiVertexBase.html#a0115e80a8874748ad4252a8f5381c9ca">addInEdge</a>(vector&lt;EdgeType&gt; &amp; x)</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;   {</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;      <span class="keywordflow">for</span> (IN_EDGE_ITERATOR it = x.begin(); it != x.end(); ++it)</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;         inEdges.push_back(*it);</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;   }</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00153"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#a7fee3ae0da7b58798d13a8c10869618b">  153</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersBiVertexBase.html#a7fee3ae0da7b58798d13a8c10869618b">removeInEdge</a>(IdType src)</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;   {</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;      <span class="keywordflow">for</span> (IN_EDGE_ITERATOR it = inEdges.begin(); it != inEdges.end(); ++it)</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;         <span class="keywordflow">if</span> (it-&gt;getNbr() == src)</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;         {</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            inEdges.erase(it);</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;         }</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;   }</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00169"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#ad2ac3cce1c4574f7e25a0c2a9f1106f4">  169</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersBiVertexBase.html#ad2ac3cce1c4574f7e25a0c2a9f1106f4">get_num_in_edges</a>()</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;   {</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;      <span class="keywordflow">return</span> inEdges.size();</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;   }</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00180"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#a91457417dfa5e01096f9a15dc1276c7b">  180</a></span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersBiVertexBase.html#a91457417dfa5e01096f9a15dc1276c7b">get_parents</a>(vector&lt;IdType&gt; &amp; vectParents)</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;   {</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;      <span class="keywordflow">for</span> (IN_EDGE_ITERATOR it = inEdges.begin(); it != inEdges.end(); ++it)</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;         vectParents.push_back(it-&gt;getNbr());</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;   }</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00191"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#ae19bca89caf25c70456b2081ca58fa9a">  191</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersBiVertexBase.html#ae19bca89caf25c70456b2081ca58fa9a">getEdgesSize</a>()</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;   {</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;      <span class="keywordflow">return</span> (inEdges.capacity() + (this-&gt;outEdges).capacity()) * <span class="keyword">sizeof</span>(EdgeType);</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;   }</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00201"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#a8628c653f7331dcc601d0162a934ee16">  201</a></span>&#160;   IN_EDGE_ITERATOR <a class="code" href="classTIGLContainersBiVertexBase.html#a8628c653f7331dcc601d0162a934ee16">getBeginInEdgeIterator</a>()</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;   {</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;      <span class="keywordflow">return</span> inEdges.begin();</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;   }</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00211"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#ab86217a05415aa2438ccb4b530c5e6ab">  211</a></span>&#160;   IN_EDGE_ITERATOR <a class="code" href="classTIGLContainersBiVertexBase.html#ab86217a05415aa2438ccb4b530c5e6ab">getEndInEdgeIterator</a>()</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;   {</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;      <span class="keywordflow">return</span> inEdges.end();</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;   }</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;   <span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00222"></a><span class="lineno"><a class="line" href="classTIGLContainersBiVertexBase.html#ab244b4eda4614655b1672b9190c0f3f2">  222</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersBiVertexBase.html#ab244b4eda4614655b1672b9190c0f3f2">isBiVertex</a>()</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;   {</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;   }   <span class="comment">// overrides base class function</span></div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;};</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLCONTAINERSBIVERTEXBASE_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="tiglContainersVertexBase_8hpp_html"><div class="ttname"><a href="tiglContainersVertexBase_8hpp.html">tiglContainersVertexBase.hpp</a></div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_ad2ac3cce1c4574f7e25a0c2a9f1106f4"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#ad2ac3cce1c4574f7e25a0c2a9f1106f4">TIGLContainersBiVertexBase::get_num_in_edges</a></div><div class="ttdeci">uint_fast32_t get_num_in_edges()</div><div class="ttdoc">Returns the number of input edges. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:169</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_afd76ce0d0b3abcb3d639041db92c4f1b"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#afd76ce0d0b3abcb3d639041db92c4f1b">TIGLContainersBiVertexBase::addInEdge</a></div><div class="ttdeci">void addInEdge(EdgeType &amp;x)</div><div class="ttdoc">Adds an input edge. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:121</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_a05f5f7777608e6b5c50f3ec7a52157e1"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#a05f5f7777608e6b5c50f3ec7a52157e1">TIGLContainersBiVertexBase::inEdges</a></div><div class="ttdeci">vector&lt; EdgeType &gt; inEdges</div><div class="ttdoc">holds the id&#39;s of the input edges and the src vertices </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:108</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_a91457417dfa5e01096f9a15dc1276c7b"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#a91457417dfa5e01096f9a15dc1276c7b">TIGLContainersBiVertexBase::get_parents</a></div><div class="ttdeci">void get_parents(vector&lt; IdType &gt; &amp;vectParents)</div><div class="ttdoc">Returns id of all parents. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:180</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_ab86217a05415aa2438ccb4b530c5e6ab"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#ab86217a05415aa2438ccb4b530c5e6ab">TIGLContainersBiVertexBase::getEndInEdgeIterator</a></div><div class="ttdeci">IN_EDGE_ITERATOR getEndInEdgeIterator()</div><div class="ttdoc">Returns pointer to the end of the input edge buffer. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:211</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_ae19bca89caf25c70456b2081ca58fa9a"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#ae19bca89caf25c70456b2081ca58fa9a">TIGLContainersBiVertexBase::getEdgesSize</a></div><div class="ttdeci">uint_fast32_t getEdgesSize()</div><div class="ttdoc">Returns the memory allocated for edge buffers. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:191</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_a7fee3ae0da7b58798d13a8c10869618b"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#a7fee3ae0da7b58798d13a8c10869618b">TIGLContainersBiVertexBase::removeInEdge</a></div><div class="ttdeci">bool removeInEdge(IdType src)</div><div class="ttdoc">Removes an input edge. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:153</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html">TIGLContainersBiVertexBase</a></div><div class="ttdoc">A vertex class with both input and output edges lists. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:74</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_ab244b4eda4614655b1672b9190c0f3f2"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#ab244b4eda4614655b1672b9190c0f3f2">TIGLContainersBiVertexBase::isBiVertex</a></div><div class="ttdeci">bool isBiVertex()</div><div class="ttdoc">Checks if TIGLContainersBiVertex. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:222</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_a0115e80a8874748ad4252a8f5381c9ca"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#a0115e80a8874748ad4252a8f5381c9ca">TIGLContainersBiVertexBase::addInEdge</a></div><div class="ttdeci">void addInEdge(vector&lt; EdgeType &gt; &amp;x)</div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:142</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_a8a442d0b79dda8ef28c14862392a2374"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#a8a442d0b79dda8ef28c14862392a2374">TIGLContainersBiVertexBase::addInEdge</a></div><div class="ttdeci">void addInEdge(IdType &amp;src)</div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:131</div></div>
<div class="ttc" id="classTIGLContainersBiVertexBase_html_a8628c653f7331dcc601d0162a934ee16"><div class="ttname"><a href="classTIGLContainersBiVertexBase.html#a8628c653f7331dcc601d0162a934ee16">TIGLContainersBiVertexBase::getBeginInEdgeIterator</a></div><div class="ttdeci">IN_EDGE_ITERATOR getBeginInEdgeIterator()</div><div class="ttdoc">Returns pointer to the start of the input edge buffer. </div><div class="ttdef"><b>Definition:</b> tiglContainersBiVertexBase.hpp:201</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html"><div class="ttname"><a href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a></div><div class="ttdoc">Core vertex class. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:89</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
